﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using System.Data;
using System.Xml;

public partial class Tickets_327691_Default : System.Web.UI.Page
{
    private void CreateHierachicalGrid()
    {
        RadGrid RadGrid1 = new RadGrid();
        RadGrid1.AutoGenerateColumns = false;
        RadGrid1.GridLines = GridLines.None;
        RadGrid1.Width = Unit.Pixel(200);

        GridBoundColumn boundColumn1;
        boundColumn1 = new GridBoundColumn();
        boundColumn1.DataField = "ItemNo";
        boundColumn1.HeaderText = "ItemNo";
        RadGrid1.MasterTableView.Columns.Add(boundColumn1);

        GridBoundColumn boundColumn2;
        boundColumn2 = new GridBoundColumn();
        boundColumn2.DataField = "ItemID";
        boundColumn2.HeaderText = "ItemID";
        RadGrid1.MasterTableView.Columns.Add(boundColumn2);

        GridTableView tableViewLevel1 = new GridTableView(RadGrid1);
        RadGrid1.MasterTableView.DetailTables.Add(tableViewLevel1);

        GridBoundColumn boundColumn3;
        boundColumn3 = new GridBoundColumn();
        boundColumn3.DataField = "ID";
        boundColumn3.HeaderText = "ID";
        tableViewLevel1.Columns.Add(boundColumn3);

        GridBoundColumn boundColumn4;
        boundColumn4 = new GridBoundColumn();
        boundColumn4.DataField = "ManufactureDate";
        boundColumn4.HeaderText = "ManufactureDate";
        tableViewLevel1.Columns.Add(boundColumn4);

        RadGrid1.NeedDataSource += new GridNeedDataSourceEventHandler(RadGrid1_NeedDataSource);
        RadGrid1.DetailTableDataBind += new GridDetailTableDataBindEventHandler(RadGrid1_DetailTableDataBind);

        PlaceHolder1.Controls.Add(RadGrid1);
    }

    private void RadGrid1_NeedDataSource(object source, GridNeedDataSourceEventArgs e)
    {
        DataSet ds = GetHierarchicalDsFromXml();
        ((RadGrid)source).DataSource = ds.Tables["Items"];
    }

    private void RadGrid1_DetailTableDataBind(object source, GridDetailTableDataBindEventArgs e)
    {
        DataSet ds = GetHierarchicalDsFromXml();
        string parentItemId = e.DetailTableView.ParentItem["ItemID"].Text;
        DataTable items = ds.Tables["Items"];
        int parentItemIndex = -1;

        for (int i = 0; i < items.Rows.Count; i++)
        {
            if (items.Rows[i]["ItemID"].ToString() == parentItemId)
            {
                parentItemIndex = i;
                break;
            }
        }
        e.DetailTableView.DataSource = ds.Tables["Description"].Select("Items_ID = " + parentItemIndex);
    }

    private DataSet tmpDataSet;

    private DataSet GetHierarchicalDsFromXml()
    {
        if (tmpDataSet != null)
        {
            return tmpDataSet;
        }

        tmpDataSet = new DataSet();
        XmlTextReader reader = new XmlTextReader(Server.MapPath("Tree.xml"));
        tmpDataSet.ReadXml(reader);

        return tmpDataSet;
    }

    protected void Page_Init(object sender, EventArgs e)
    {
        CreateHierachicalGrid();
    }
}